import { State } from '../state';
import { DataResult } from '../data-result.interface';
import { CancelToken } from 'axios';
import { DataSource, IdType } from './data-source';
interface Operations<T, TId> {
    get(state: State, cancelToken?: CancelToken): Promise<DataResult<T>>;
    add?(item: T, index?: number): Promise<T>;
    update?(id: TId, changes: Partial<T>): Promise<void>;
    remove?(id: TId): Promise<T | undefined>;
}
export declare class AsyncDataSource<T, TId extends IdType = never> implements DataSource<T, TId> {
    idSelector?: (row: T) => TId;
    private operations;
    private withCache?;
    private cached?;
    private cancelation?;
    constructor(operations: Operations<T, TId>, idSelector?: (row: T) => TId, withCache?: boolean);
    getData(state: State): Promise<DataResult<T>>;
    addData(row: T, index?: number): Promise<T>;
    updateData(id: TId, changes: Partial<T>): Promise<void>;
    removeData(id: TId): Promise<T>;
}
export {};
//# sourceMappingURL=async-data-source.d.ts.map