import { State } from '../state';
import { Preprocessors } from '../common.interfaces';
import { CompositeFilterDescriptor } from '../filtering/filter-descriptor.interface';
import { DataResult } from '../data-result.interface';
import { DataSource, IdType } from './data-source';
export declare class InMemoryDataSource<T, TId extends IdType = never> implements DataSource<T, TId> {
    idSelector?: (row: T) => TId;
    private clone;
    private data;
    private preprocessors;
    private cached?;
    constructor(data: T[], idSelector?: (row: T) => TId, preprocessors?: Preprocessors<T>, { cloneCustomizer }?: {
        cloneCustomizer?: (value: any) => any;
    });
    getData(state: State): Promise<DataResult<T>>;
    addData(row: T, index?: number): Promise<Awaited<T>>;
    updateData(id: TId, changes: Partial<T>): Promise<void>;
    removeData(id: TId): Promise<T>;
    getFilteredPersistentItems(filter: CompositeFilterDescriptor): T[];
}
//# sourceMappingURL=in-memory-data-source.d.ts.map