import { FilterDescriptor, CompositeFilterDescriptor } from './filtering/filter-descriptor.interface';
/**
 * @hidden
 */
export type Transformation = (x: FilterDescriptor) => FilterDescriptor;
/**
 * @hidden
 * Creates a single arity function which wraps the value based on the provided predicate.
 * @example
 * ```
 * wrapIf(() => ignoreCase) `tolower(${field})`
 * //ignoreCase=true -> tolower(${field})`
 * //ignoreCase=false -> ${field}`
 * ```
 */
export declare const wrapIf: (predicate: any) => (str: any, ...args: any[]) => any;
/**
 * @hidden
 */
export declare const toUTC: (date: Date) => Date;
/**
 * @hidden
 */
export declare const quote: Transformation;
/**
 * @hidden
 */
export declare const encodeValue: Transformation;
/**
 * @hidden
 */
export declare const toLower: Transformation;
/**
 * @hidden
 */
export declare const normalizeField: Transformation;
/**
 * @hidden
 */
export declare const isStringValue: (x: any) => any;
/**
 * @hidden
 */
export declare const isDateValue: (x: any) => any;
/**
 * @hidden
 */
export declare const serializeFilters: (map: any, join: any) => (filter: CompositeFilterDescriptor) => string;
//# sourceMappingURL=filter-serialization.common.d.ts.map